All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Pages
DrudeSCFIntegrator Class Reference

This is a leap-frog Verlet Integrator that simulates systems with Drude particles. More...

`#include <DrudeSCFIntegrator.h>`

Inheritance diagram for DrudeSCFIntegrator:

## Public Member Functions

| DrudeSCFIntegrator (double stepSize)
| Create a DrudeSCFIntegrator. More...
double | getMinimizationErrorTolerance () const
| Get the error tolerance to use when minimizing the potential energy. More...
void | setMinimizationErrorTolerance (double tol)
| Set the error tolerance to use when minimizing the potential energy. More...
void | step (int steps)
| Advance a simulation through time by taking a series of time steps. More...
Public Member Functions inherited from Integrator
| Integrator ()
virtual | ~Integrator ()
double | getStepSize () const
| Get the size of each time step, in picoseconds. More...
void | setStepSize (double size)
| Set the size of each time step, in picoseconds. More...
double | getConstraintTolerance () const
| Get the distance tolerance within which constraints are maintained, as a fraction of the constrained distance. More...
void | setConstraintTolerance (double tol)
| Set the distance tolerance within which constraints are maintained, as a fraction of the constrained distance. More...

## Protected Member Functions

void | initialize (ContextImpl &context)
| This will be called by the Context when it is created. More...
void | cleanup ()
| This will be called by the Context when it is destroyed to let the Integrator do any necessary cleanup. More...
void | stateChanged (State::DataType changed)
| When the user modifies the state, we need to mark that the forces need to be recalculated. More...
std::vector< std::string > | getKernelNames ()
| Get the names of all Kernels used by this Integrator. More...
double | computeKineticEnergy ()
| Compute the kinetic energy of the system at the current time. More...

## Additional Inherited Members

Protected Attributes inherited from Integrator
ContextImpl * | context
Context * | owner

## Detailed Description

This is a leap-frog Verlet Integrator that simulates systems with Drude particles.

It uses the self-consistent field (SCF) method: at every time step, the positions of Drude particles are adjusted to minimize the potential energy.

This Integrator requires the System to include a DrudeForce, which it uses to identify the Drude particles.

## Constructor & Destructor Documentation

DrudeSCFIntegrator | ( | double | stepSize | ) |

Create a DrudeSCFIntegrator.

Parameters

  stepSize | the step size with which to integrator the system (in picoseconds)

## Member Function Documentation

void cleanup | ( |  | ) |

protectedvirtual

This will be called by the Context when it is destroyed to let the Integrator do any necessary cleanup.

It will also get called again if the application calls reinitialize() on the Context.

Reimplemented from Integrator.

double computeKineticEnergy | ( |  | ) |

protectedvirtual

Compute the kinetic energy of the system at the current time.

Implements Integrator.

std::vector<std::string> getKernelNames | ( |  | ) |

protectedvirtual

Get the names of all Kernels used by this Integrator.

Implements Integrator.

double getMinimizationErrorTolerance | ( |  | ) | const

inline

Get the error tolerance to use when minimizing the potential energy.

This roughly corresponds to the maximum allowed force magnitude on the Drude particles after minimization.

Returns
  the error tolerance to use, measured in kJ/mol/nm

void initialize | ( | ContextImpl & | context | ) |

protectedvirtual

This will be called by the Context when it is created.

It informs the Integrator of what context it will be integrating, and gives it a chance to do any necessary initialization. It will also get called again if the application calls reinitialize() on the Context.

Implements Integrator.

void setMinimizationErrorTolerance | ( | double | tol | ) |

inline

Set the error tolerance to use when minimizing the potential energy.

This roughly corresponds to the maximum allowed force magnitude on the Drude particles after minimization.

Parameters

  tol | the error tolerance to use, measured in kJ/mol/nm

void stateChanged | ( | State::DataType | changed | ) |

protectedvirtual

When the user modifies the state, we need to mark that the forces need to be recalculated.

Reimplemented from Integrator.

void step | ( | int | steps | ) |

virtual

Advance a simulation through time by taking a series of time steps.

Parameters

  steps | the number of time steps to take

Implements Integrator.

The documentation for this class was generated from the following file:

- DrudeSCFIntegrator.h